import org.cloudfoundry.client.lib.CloudCredentials;
import org.cloudfoundry.client.lib.CloudFoundryClient;
import org.cloudfoundry.client.lib.archive.ApplicationArchive;
import org.cloudfoundry.client.lib.archive.ZipApplicationArchive;
import org.cloudfoundry.client.lib.domain.CloudApplication;
import org.cloudfoundry.client.lib.domain.CloudEntity.Meta;
import org.cloudfoundry.client.lib.domain.CloudEntity;
import org.cloudfoundry.client.lib.domain.CloudOrganization;
import org.cloudfoundry.client.lib.domain.CloudService;
import org.cloudfoundry.client.lib.domain.CloudSpace;
import org.cloudfoundry.client.lib.domain.Staging;

import com.sun.org.apache.xalan.internal.xsltc.compiler.sym;

import telecom.sudparis.eu.paas.core.server.pool.application.ApplicationPool;
import telecom.sudparis.eu.paas.core.server.ressources.util.ApplicationLinkGenerator;
import telecom.sudparis.eu.paas.core.server.xml.LinksListType;
import telecom.sudparis.eu.paas.core.server.xml.application.ApplicationType;
import telecom.sudparis.eu.paas.core.server.xml.application.UrisType;
import telecom.sudparis.eu.paas.core.server.xml.environment.ConfigurationType;
import telecom.sudparis.eu.paas.core.server.xml.environment.EntryType;
import telecom.sudparis.eu.paas.core.server.xml.environment.EnvironmentType;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URL;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.zip.ZipFile;

public class JavaSample {
	/**
	 * ressource bundle to get the connexion credentials
	 */
	private static ResourceBundle rb = ResourceBundle
			.getBundle("telecom.sudparis.eu.paas.core.server.ressources.credentials");
	/**
	 * The target cloud Foundry URL
	 */
	private static final String ccUrl = rb.getString("vcap.target");

	/**
	 * The public CF-PaaS API URL
	 */
	private static String apiUrl = rb.getString("api.public.url");

	/**
	 * The CloudFoundry user mail
	 */
	private static final String TEST_USER_EMAIL = rb.getString("vcap.email");

	/**
	 * The CloudFoundry user password
	 */
	private static final String TEST_USER_PASS = rb.getString("vcap.passwd");
	
	 public static void main(String[] args) {
	
			  CloudCredentials credentials = new CloudCredentials(TEST_USER_EMAIL, TEST_USER_PASS);
		       CloudFoundryClient client = new CloudFoundryClient(credentials, getTargetURL(ccUrl));
		        client.login();
		        List<CloudSpace> lst=client.getSpaces();
		        CloudSpace cs=null;
		        
		       // int cloudSpaceIndex=-1;
		        for (CloudSpace c:lst){
	
		        	if (c.getName().equalsIgnoreCase("development")){
		        		cs=c;
		        	}
		        }
		        
		    //client1.logout();
		    //CloudSpace cs=client1.getSpaces().get(cloudSpaceIndex);				
			//CloudSpace cs=new CloudSpace(CloudEntity.Meta.defaultMeta(), spaceName, new CloudOrganization(CloudEntity.Meta.defaultMeta(), organization));
				
		    client = new CloudFoundryClient(credentials, getTargetURL(ccUrl),cs);
		    client.login();
						
			List<String> lstS=new ArrayList<String>();
			lstS.add("mysql");
			
			
			if (lstS.get(0).toLowerCase().contains("sql")) 
				if (!serviceExists(lstS.get(0), client))
					createMySqlService(lstS.get(0), client);
			

			
		/*CloudService service = new CloudService(CloudEntity.Meta.defaultMeta(), lstS.get(0));

				service.setLabel("cleardb");
				service.setPlan("spark");
				service.setVersion("n/a");


				client.createService(service);*/
				
			
			List<String> uris = new ArrayList<String>();
			String appName = "travel_test-0";
			uris.add(computeAppUrl(appName));
			Staging staging =  new Staging(null,null);
			client.createApplication(appName, staging,512, uris, lstS);
			try {
				//
				File file=new File("/home/mehdi/Bureau/COAPS/1.5.3V2/test-resources/sampleApplication/SampleServlet.war");
				//client.uploadApplication(appName, );
				ZipFile zipFile = new ZipFile(file);
				ApplicationArchive appArchive = new ZipApplicationArchive(
						zipFile);
				client.uploadApplication(appName, appArchive);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		//	CloudApplication app = client.getApplication(appName);
			//System.out.println(app.getName());
			List<CloudApplication> apps=client.getApplications();
			for (Iterator iterator = apps.iterator(); iterator.hasNext();) {
				CloudApplication cloudApplication = (CloudApplication) iterator
						.next();
				System.out.println("app " +cloudApplication);
				
			}
			
	 }
	
//    public static void main(String[] args) {
//        String target = "https://api.run.pivotal.io";
//        String user = "mohamed.mohamed@it-sudparis.eu";
//        String password = "budfSzrq";
//        String spaceName = "developement";
//        String organization="telecomsudparis";
//        CloudOrganization org=new CloudOrganization(null, organization);
//      
//       
//        
//        CloudCredentials credentials = new CloudCredentials(user, password);
//       /* CloudFoundryClient client1 = new CloudFoundryClient(credentials, getTargetURL(target));
//        client1.login();
//        CloudSpace cs=client1.getSpaces().get(0);
//        client1.logout();*/
//		
//		//CloudSpace cs=new CloudSpace(CloudEntity.Meta.defaultMeta(), spaceName, new CloudOrganization(CloudEntity.Meta.defaultMeta(), organization));
//		
//        CloudFoundryClient client = new CloudFoundryClient(credentials, getTargetURL(target));
//        CloudSpace theSpace=null;
//        client.login();
//        List<CloudSpace> lst=client.getSpaces();
//        for(CloudSpace cs:lst){
//        	if (cs.getName().equals(spaceName))
//        		theSpace=cs;
//        }
//        client.logout();
//        client = new CloudFoundryClient(credentials, getTargetURL(target),theSpace);
//        client.login();
//        System.out.println("+++++++++++++"+client.getSpaces().get(0).getName());
//        System.out.println("+++++++++++++"+client.getSpaces().get(0).getMeta().get);
//        
//    /*   List<CloudSpace> listSpace=client.getSpaces();
//       CloudSpace cloudSpace=null;
//       if (listSpace!=null)
//    	   for(CloudSpace c:listSpace){
//    		   if (c.getName().toLowerCase().equals(spaceName.toLowerCase()))
//    			   cloudSpace=c;
//    	   }*/
//       
//      // client.getApplicationPlans().get(0).toString();
//       // CloudSpace sessionSpace=new CloudSpace(meta, spaceName, organization);
//        //CloudFoundryClient client1 = new CloudFoundryClient(credentials, getTargetURL(target), sessionSpace)
//
//
//        System.out.println("\nSpaces:");
//        for (CloudSpace space : client.getSpaces()) {
//        	
//            System.out.println(space.getName() + ":" + space.getOrganization().getName());
//        }
//
//        System.out.println("\nApplications:");
//        for (CloudApplication app : client.getApplications()) {
//            System.out.println(app.getName());
//        }
//
//        System.out.println("\nServices");
//        for (CloudService service : client.getServices()) {
//            System.out.println(service.getName() + ":" + service.getLabel());
//        }
//
//        
//        
//        List<String> uris = new ArrayList<String>();
//		String appName = "travel_test-0";
//		uris.add(computeAppUrl(appName));
//		Staging staging =  new Staging("spring");
//		staging.setRuntime("java");
//		client.createApplication(appName, staging,
//				client.getDefaultApplicationMemory("spring"), uris, null);
//		//CloudApplication app = client.getApplication(appName);
//		//System.out.println(app.getName()); 
//		
//        /*Staging staging = new Staging("java", "java_web");
//        List<String> lst=new ArrayList<String>();
//        lst.add("sample1245758.cfapps.io");
//        List<String> lst1=new ArrayList<String>();
//
//        client.createApplication("test", staging,
//				256, lst,
//				lst1);*/
//  
//        System.out.println("\nApplications:");
//        for (CloudApplication appl : client.getApplications()) {
//            System.out.println(appl.getName());
//        }
//    }

    private static URL getTargetURL(String target) {
        try {
            return new URI(target).toURL();
        } catch (Exception e) {
            System.out.println("The target URL is not valid: " + e.getMessage());
        }
        System.exit(1);
        return null;
    }
    protected static String computeAppUrl(String appName) {
    	String target = ".cfapps.io";
		return "http://"+appName+target;
	}
    
    private static void copyDeployedApps2Pool() {

			CloudFoundryClient client = null;
			List<CloudApplication> appListCF = null;
			client = new CloudFoundryClient(new CloudCredentials(
					TEST_USER_EMAIL, TEST_USER_PASS), getTargetURL(ccUrl));
				client.login();
				appListCF = client.getApplications();
				System.out.println(appListCF.get(0).getName());
				client.logout();
				
				for (CloudApplication ca : appListCF) {
					String id = Long.toString(getNextId());
					ApplicationType app = new ApplicationType();
					app.setAppId(Integer.parseInt(id));
					app.setAppName(ca.getName());
					// app.setCheckExists(CHECK_EXISTS);
					// app.setMemory(ca.getMemory());

					// Since we can not recreate an environment, we recover only the
					// configuration
					// elements and the memory
					EnvironmentType env = new EnvironmentType();
					ConfigurationType conf = new ConfigurationType();
//
//					// get the runtime
//					EntryType runtime = new EntryType();
//					runtime.setKey("runtime");
//					runtime.setValue(ca.getStaging().getRuntime());
//					conf.getEntry().add(runtime);
//
//					// get the framework
//					EntryType framework = new EntryType();
//					framework.setKey("framework");
//					framework.setValue(ca.getStaging().getFramework());
//					conf.getEntry().add(framework);

					// get the service Names
					for (String service : ca.getServices()) {
						EntryType e = new EntryType();
						e.setKey("service");
						e.setValue(service);
						conf.getEntry().add(e);
					}
					env.setConfiguration(conf);
					env.setEnvMemory(ca.getResources().get("memory"));
					app.setEnvironment(env);
					app.setStatus(ca.getState().toString());
					UrisType uris = new UrisType();
					uris.getUri().addAll(ca.getUris());
					app.setUris(uris);
					app.setNbInstances(ca.getInstances());

					LinksListType linksList = new LinksListType();
					linksList = ApplicationLinkGenerator.addDescribeAppLink(
							linksList, id, apiUrl);
					linksList = ApplicationLinkGenerator.addDestroyAppLink(
							linksList, id, apiUrl);
					linksList = ApplicationLinkGenerator.addCreateAppLink(
							linksList, apiUrl);
					linksList = ApplicationLinkGenerator.addFindAppsLink(linksList,
							apiUrl);
					linksList = ApplicationLinkGenerator.addUpdateAppLink(
							linksList, id, apiUrl);
					linksList = ApplicationLinkGenerator.addStartAppLink(linksList,
							id, apiUrl);
					linksList = ApplicationLinkGenerator.addStopAppLink(linksList,
							id, apiUrl);
					linksList = ApplicationLinkGenerator.addRestartAppLink(
							linksList, id, apiUrl);

					app.setLinksList(linksList);
					ApplicationPool.INSTANCE.add(app);
				}

			}
	private synchronized static Long getNextId() {
		return new Long(ApplicationPool.INSTANCE.getNextID());
	}
		
	private static ApplicationType findAssociatedAppInThePool(String appName) {
		List<ApplicationType> appListPool = ApplicationPool.INSTANCE
				.getAppList();
		for (ApplicationType poolApp : appListPool) {
			if (poolApp.getAppName().equals(appName))
				return poolApp;
		}
		return null;
	}
    
	private static boolean serviceExists(String serviceName, CloudFoundryClient client) {

			if (client.getService(serviceName)==null)
				return false;
			else return true;

	}
	private static void createMySqlService(String serviceName,
			CloudFoundryClient client) {
		CloudService service = new CloudService(CloudEntity.Meta.defaultMeta(),
				serviceName);
		

		service.setLabel("cleardb");
		service.setPlan("spark");
		service.setVersion("n/a");
	
		client.createService(service);
	}
	}
    
