package telecom.sudparis.eu.paas.core.server.ressources.manager.application;


import com.amazonaws.auth.AWSCredentials;
import com.amazonaws.services.ec2.AmazonEC2;
import com.amazonaws.services.ec2.AmazonEC2Client;
import com.amazonaws.services.ec2.model.IpPermission;
import com.amazonaws.services.ec2.model.RevokeSecurityGroupIngressRequest;
import com.amazonaws.services.elasticbeanstalk.model.ApplicationDescription;
import com.amazonaws.services.elasticbeanstalk.AWSElasticBeanstalk;
import com.amazonaws.services.elasticbeanstalk.AWSElasticBeanstalkAsync;
import com.amazonaws.services.elasticbeanstalk.AWSElasticBeanstalkClient;
import com.amazonaws.services.elasticbeanstalk.AWSElasticBeanstalkAsyncClient;
import com.amazonaws.services.elasticbeanstalk.model.ApplicationVersionDescription;
import com.amazonaws.services.elasticbeanstalk.model.CreateApplicationResult;
import com.amazonaws.services.elasticbeanstalk.model.CreateApplicationRequest;
import com.amazonaws.services.elasticbeanstalk.model.CreateApplicationVersionRequest;
import com.amazonaws.services.elasticbeanstalk.model.DeleteApplicationRequest;
import com.amazonaws.services.elasticbeanstalk.model.DeleteApplicationVersionRequest;
import com.amazonaws.services.elasticbeanstalk.model.DescribeApplicationVersionsRequest;
import com.amazonaws.services.elasticbeanstalk.model.DescribeApplicationsRequest;
import com.amazonaws.services.elasticbeanstalk.model.DescribeEnvironmentsRequest;
import com.amazonaws.services.elasticbeanstalk.model.EnvironmentDescription;
import com.amazonaws.services.elasticbeanstalk.model.DescribeApplicationsResult;
import com.amazonaws.services.elasticbeanstalk.model.S3Location;
import com.amazonaws.services.elasticbeanstalk.model.TerminateEnvironmentRequest;
import com.amazonaws.services.elasticbeanstalk.model.TerminateEnvironmentResult;
import com.amazonaws.services.elasticbeanstalk.model.UpdateEnvironmentRequest;
import com.amazonaws.services.elasticbeanstalk.model.UpdateEnvironmentResult;
import com.amazonaws.services.elasticbeanstalk.model.UpdateApplicationResult;
import com.amazonaws.services.elasticbeanstalk.model.UpdateApplicationRequest;
import com.amazonaws.services.s3.AmazonS3;
import com.amazonaws.services.s3.AmazonS3Client;
import com.amazonaws.services.s3.model.CreateBucketRequest;
import com.amazonaws.services.s3.model.PutObjectResult;
import com.amazonaws.services.s3.model.DeleteObjectRequest;
import com.amazonaws.services.s3.model.Bucket;
import com.amazonaws.services.s3.transfer.TransferManager;
import com.amazonaws.services.s3.transfer.Upload;
import com.amazonaws.regions.Region;
import com.amazonaws.regions.Regions;



import com.amazonaws.AmazonClientException;
import com.amazonaws.auth.profile.ProfileCredentialsProvider;





import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
//import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import javax.naming.spi.DirStateFactory.Result;
import javax.ws.rs.Path;
import javax.ws.rs.core.GenericEntity;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.transform.stream.StreamSource;

import  telecom.sudparis.eu.paas.core.server.pool.application.ApplicationPool2;
import  telecom.sudparis.eu.paas.core.server.pool.environment.EnvironmentPool2;
import  telecom.sudparis.eu.paas.core.server.ressources.exception.NotSupportedException;
import  telecom.sudparis.eu.paas.core.server.ressources.util.ApplicationLinkGenerator;
import telecom.sudparis.eu.paas.core.server.ressources.util.FileUtilities;
import  telecom.sudparis.eu.paas.core.server.xml.Error;
import  telecom.sudparis.eu.paas.core.server.xml.LinksListType;
import  telecom.sudparis.eu.paas.core.server.xml.OperationResponse;
import  telecom.sudparis.eu.paas.core.server.xml.application.ApplicationType;
import  telecom.sudparis.eu.paas.core.server.xml.application.DeployableType;
import  telecom.sudparis.eu.paas.core.server.xml.application.InstanceType;
import  telecom.sudparis.eu.paas.core.server.xml.application.InstancesType;
import  telecom.sudparis.eu.paas.core.server.xml.application.UrisType;
import  telecom.sudparis.eu.paas.core.server.xml.application.list.ApplicationsType;
import  telecom.sudparis.eu.paas.core.server.xml.application.list.SimpleApplicationType;
import  telecom.sudparis.eu.paas.core.server.xml.environment.EnvironmentType;
import telecom.sudparis.eu.paas.core.server.xml.manifest.PaasApplicationComponentType;
import telecom.sudparis.eu.paas.core.server.xml.manifest.PaasApplicationDeployableType;
import  telecom.sudparis.eu.paas.core.server.xml.manifest.PaasApplicationManifest;
import  telecom.sudparis.eu.paas.core.server.xml.manifest.PaasApplicationVersionInstanceType;
import telecom.sudparis.eu.paas.core.server.xml.manifest.PaasApplicationVersionType;
import  telecom.sudparis.eu.paas.api.ressources.manager.application.RestApplicationManager;

/**
 * 
 * @author Mehdi Ahmed-Nacer (Telecom SudParis)
 * 
 */

public class AmazonManageApplication extends Thread{
	private static ResourceBundle rb = ResourceBundle
			.getBundle("telecom.sudparis.eu.paas.core.server.ressources.credentials_aws");
	private static final String ccUrl = rb.getString("vcap.target");
	private static final String HOST_NAME = rb.getString("host");
	private static String apiUrl = rb.getString("api.public.url");
	private Error error = new Error();
	private static String localTempPath = System.getProperty("java.io.tmpdir");
	private static boolean checkEBApplications = false;
	static AmazonEC2      ec2;
	static AmazonS3       s3;
	static AWSElasticBeanstalkAsync ebas;
	static AWSElasticBeanstalk eb;    
	
	String appwar, envwar;
	InputStream war;

	public AmazonManageApplication(){
	}
	public AmazonManageApplication(String app, String env, InputStream war){
		this.appwar = app;
		this.envwar = env;
		this.war = war;
	}

	private static void init() throws Exception {

		AWSCredentials credentials = null;
		try {
			credentials = new ProfileCredentialsProvider("default").getCredentials();
		} catch (Exception e) {
			throw new AmazonClientException(
					"Cannot load the credentials from the credential profiles file. " +
							"Please make sure that your credentials file is at the correct " +
							"and is in valid format.",e);
		}
		ec2 = new AmazonEC2Client(credentials);
		s3  = new AmazonS3Client(credentials);
		eb =  new AWSElasticBeanstalkClient(credentials);
		ebas = new AWSElasticBeanstalkAsyncClient(credentials);

	}

	/***************************************************************************************/
	/**************************** createApplication methods ***************************/
	/***************************************************************************************/

	public ApplicationType createApplication(String cloudApplicationDescriptor) {

		try {
			init();
			copyDeployedApps2Pool();
			if (cloudApplicationDescriptor != null
					&& !cloudApplicationDescriptor.equals("")) {
				InputStream is = new ByteArrayInputStream(
						cloudApplicationDescriptor.getBytes());
				JAXBContext jaxbContext;
				PaasApplicationManifest manifest = new PaasApplicationManifest();
				try {
					jaxbContext = JAXBContext
							.newInstance("telecom.sudparis.eu.paas.core.server.xml.manifest");
					Unmarshaller jaxbUnmarshaller = jaxbContext
							.createUnmarshaller();

					JAXBElement<PaasApplicationManifest> root = jaxbUnmarshaller
							.unmarshal(new StreamSource(is),
									PaasApplicationManifest.class);
					manifest = root.getValue();

				} catch (JAXBException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				PaasApplicationComponentType component  = 
						manifest.getPaasApplication().getPaasApplicationComponent().get(1);
				String appName = component.getName();

				// retrieve app description
				String description = component.getDescription().toString();
				//Create application in AWS elasticbenastalk
				CreateApplicationRequest r=new CreateApplicationRequest(appName);
				r.setDescription(description);

				CreateApplicationResult c=eb.createApplication(r);
				//retrieve deployableName
				PaasApplicationDeployableType deployable = component
						.getPaasApplicationVersion().get(0)
						.getPaasApplicationDeployable().get(0);

				String deployableName = deployable.getName();
				
				// retrieve ApplicationVersionInstance Names and number
				PaasApplicationVersionType version = component.getPaasApplicationVersion().get(0);
				List<PaasApplicationVersionInstanceType> listOfInstances =version.getPaasApplicationVersionInstance();

				InstancesType listVI = new InstancesType();
				int nbInstances = 0;

				if (listOfInstances != null && listOfInstances.size() > 0)
					for (PaasApplicationVersionInstanceType p : listOfInstances) {
						if (p != null) {
							InstanceType vi = new InstanceType();
							vi.setInstanceName(p.getName());
							listVI.getInstance().add(vi);
							nbInstances++;

						}
					}

				// create the application object
				ApplicationType app = new ApplicationType();
				app.setAppName(appName);
				app.setDescription(description);
				// generate appID
				Long id = getNextId();
				app.setAppId((int) (long) id);


				// retrieve envName
				String envName = manifest.getPaasApplication().getPaasEnvironment().get(1).getName();

				// retrieve uris
				UrisType uris = new UrisType();
				uris.getUri().add(appName +"COAPS"+envName + "." + HOST_NAME);
				app.setUris(uris);

				// retrieve deployableType
				String deployableType = deployable.getContentType();

				// retrieve deployableDirectory or deployableId
				//String deployableId = null;
				String deployableDirectory = deployable.getLocation();
				// if the deployable is already in the DB we provide it's ID
				DeployableType dep = new DeployableType();
				if (!(deployableDirectory.contains("/") || deployableDirectory
						.contains("\\"))) {
					dep.setDeployableId(deployableDirectory);
				}
				// Define the deployable element
				else {

					dep.setDeployableDirectory(deployableDirectory);

				}
				dep.setDeployableName(deployableName);
				dep.setDeployableType(deployableType);
				app.setDeployable(dep);




				// Update the Application object with the
				// Adequate LinkList
				LinksListType linksList = new LinksListType();
				linksList = ApplicationLinkGenerator.addDescribeAppLink(
						linksList, id.toString(), apiUrl);
				linksList = ApplicationLinkGenerator.addCreateAppLink(
						linksList, apiUrl);
				linksList = ApplicationLinkGenerator.addDestroyAppLink(
						linksList, id.toString(), apiUrl);
				linksList = ApplicationLinkGenerator.addFindAppsLink(linksList,
						apiUrl);
				linksList = ApplicationLinkGenerator.addUpdateAppLink(
						linksList, id.toString(), apiUrl);

				app.setLinksList(linksList);
				app.setInstances(listVI);
				app.setNbInstances(nbInstances);
				// app.setCheckExists(CHECK_EXISTS);
				app.setStatus("CREATED");

				ApplicationPool2.INSTANCE2.add(app);
				return app;
			} else {
				System.out
				.println("Failed to retrieve the cloud Application Descriptor");
				error.setValue("Failed to retrieve the cloud Application Descriptor.");
				return null;
			}
		} catch (Exception e) {
			System.out.println("Failed to create the application: "
					+ e.getMessage());
			e.printStackTrace();
			error.setValue("Failed to create the application: "
					+ e.getMessage());
			return null;
		}
	}



	/***************************************************************************************/
	/**************************** deployApplication methods ***************************/
	/***************************************************************************************/

	public Response deployApplication(String appid, String envid,
			InputStream uploadedInputStream) {

		
		try {
			init();
			String versionLabel="";
			
			
			EnvironmentType env = EnvironmentPool2.INSTANCE2.getEnv(envid);
          	
			ApplicationType app = ApplicationPool2.INSTANCE2.getApp(appid);
			
			String appName=app.getAppName();
			String envName=env.getEnvName();
			
			// update uris
			UrisType uris = new UrisType();
			uris.getUri().add(appName +"COAPS"+envName + "." + HOST_NAME);
			app.setUris(uris);
			
			app.setStatus("DEPLOYED");
           
			ApplicationPool2.INSTANCE2.updateApp(appid, app);
	    
			
			DeployableType dep=app.getDeployable();
			
            String deployableName= dep.getDeployableName();
			
			String desc=app.getDescription();
			
		    
		    
		 // We start by uploading the application files

		 			

		 			String artefactId = app.getDeployable().getDeployableId();
		 			String uploadedFileLocation = localTempPath + "/"
		 					+ app.getDeployable().getDeployableName();
		 		
		 				FileUtilities.writeToFile(uploadedInputStream,
		 						uploadedFileLocation);
		 				InputStream is = new FileInputStream(new File(
		 						uploadedFileLocation));


		 			// redefine the deployable element according to the uploaded
		 			// file location
		 			DeployableType newDep = new DeployableType();
		 			newDep.setDeployableDirectory(localTempPath);
		 			newDep.setDeployableName(app.getDeployable()
		 					.getDeployableName());
		 			newDep.setDeployableType(app.getDeployable()
		 					.getDeployableType());
		 			newDep.setDeployableId(artefactId);

		 			// update the application pool
		 	       ApplicationPool2.INSTANCE2.updateApp(appid, newDep);	
		 			
		 			// TODO upload Application we treated only the case of an
		 			// artifact
		 			if (app.getDeployable().getDeployableType().equals("artifact")) {
		 				String artefactFileName = app.getDeployable()
		 						.getDeployableName();
		 				String artefactFilePath = app.getDeployable()
		 						.getDeployableDirectory().replace("\\", "/");
		 				if (!artefactFilePath.endsWith("/"))
		 					artefactFilePath = artefactFilePath + "/";
		 				
		 				File artefactFile = new File(artefactFilePath
		 						+ artefactFileName);
		 										
						
						/******create S3 bucket***/
		 				
		 				/******Transfer Manager****/
		 				
						String S3Bucket="coapseb";
						String S3Key=artefactFileName;
						
						Bucket b =s3.createBucket(new CreateBucketRequest(S3Bucket));
			        	TransferManager tm=new TransferManager(s3);
			        	Upload myUpload = tm.upload(S3Bucket, S3Key, artefactFile);
				
				         
			        	myUpload.waitForCompletion();
			        	tm.shutdownNow();
			        	
						 S3Location s=new S3Location(S3Bucket,S3Key);
						 s.setS3Bucket(S3Bucket);
						 s.setS3Key(S3Key);

								
										 
						 /******Creer une version*****/
					
							
							int nbInstances = app.getNbInstances();

							 InstancesType ins=app.getInstances();
							 List<InstanceType> inst =ins.getInstance();
							 
							
                           if(nbInstances>0 && inst.size()>0){
                            	   for (InstanceType p : inst) {
									versionLabel=p.getInstanceName();
										nbInstances--;
									}
								}
						 CreateApplicationVersionRequest v=new CreateApplicationVersionRequest(appName,desc);
						 
							v.setVersionLabel(versionLabel);
								v.setSourceBundle(s);

								eb.createApplicationVersion(v);
							
		 			
								
								/*****************************Update un environnement***************************************************/
									
										
										
	                   UpdateEnvironmentRequest up=new UpdateEnvironmentRequest();
	                   
						 up.setEnvironmentName(envName);
						 up.setDescription(desc);
						 up.setVersionLabel(versionLabel);
						
							// UpdateEnvironmentResult resu= ebas.updateEnvironment(up);
							 Future future = ebas.updateEnvironmentAsync(up);
							 
						
							    while (!future.isDone()) {
							        Thread.sleep(120000);
							        // Do other processing while you're waiting for the response
							    }

							    try {
							    								   
							    	UpdateEnvironmentResult result = (UpdateEnvironmentResult) future.get();
							 
							   	 versionLabel=result.getVersionLabel(); 
							      } catch (ExecutionException ee) {
							        // Futures always wrap errors as an ExecutionException.
							        // The *real* exception is stored as the cause of the ExecutionException
							        Throwable exception = ee.getCause();
							        System.out.println("Error updating: " + exception.getMessage());
							       
							     
							  	 		
		 			}
								
		 			}
					// delete the temp uploaded deployable
					FileUtilities.deletefile(uploadedFileLocation);
					// update the Application with describeApp and deleteApp links
					LinksListType linksList = ApplicationPool2.INSTANCE2.getApp(appid)
							.getLinksList();
					linksList = ApplicationLinkGenerator.addStartAppLink(linksList,
							appid, apiUrl);
					linksList = ApplicationLinkGenerator.addStopAppLink(linksList,
							appid, apiUrl);
					linksList = ApplicationLinkGenerator.addRestartAppLink(linksList,
							appid, apiUrl);

					ApplicationPool2.INSTANCE2.updateApp(appid, linksList);
					// adds the envID to the deployed application
					ApplicationPool2.INSTANCE2.updateApp(appid, envid);
		 			
		 			return Response.status(Response.Status.OK).entity(app)
		 					.type(MediaType.APPLICATION_XML_TYPE).build();
		 			
		 		} catch (Exception e) {
		 			System.out.println("Failed to deploy the application: "
		 					+ e.getMessage());
		 			e.printStackTrace();
		 			error.setValue("Failed to deploy the application: "
		 					+ e.getMessage());
		 			return Response.status(Response.Status.INTERNAL_SERVER_ERROR)
		 					.entity(error).type(MediaType.APPLICATION_XML_TYPE).build();
		 		}
		
	
	}

	/***************************************************************************************/
	/**************************** Private methods ******************************************/
	/***************************************************************************************/

	private void copyDeployedApps2Pool() throws Exception {

		if (!checkEBApplications) {
			checkEBApplications = true;
			AWSElasticBeanstalkClient client = null;
			List<ApplicationDescription> appListEB = null;

			client = new AWSElasticBeanstalkClient();	
			init();
			appListEB = client.describeApplications().getApplications();
			client.shutdown();


			// List<Application> appListPool = appPool.INSTANCE.getAppList();
			for (ApplicationDescription ca : appListEB) {

				String id = Long.toString(getNextId());

				ApplicationType app = new ApplicationType();

				app.setAppId(Integer.parseInt(id));

				app.setAppName(ca.getApplicationName());

				EnvironmentType env = new EnvironmentType();

				EnvironmentDescription e=new EnvironmentDescription();	

				app.setEnvironment(env);

				// app.setUris(e.getEndpointURL());

				//app.setStatus(ca.getState().toString());

				/*add the environment'url*/
				UrisType uris = new UrisType();
				uris.getUri().add(e.getEndpointURL());
				app.setUris(uris);

				//app.setNbInstances(ca.getInstances());

				LinksListType linksList = new LinksListType();
				linksList = ApplicationLinkGenerator.addDescribeAppLink(
						linksList, id, apiUrl);
				linksList = ApplicationLinkGenerator.addDestroyAppLink(
						linksList, id, apiUrl);
				linksList = ApplicationLinkGenerator.addCreateAppLink(
						linksList, apiUrl);
				linksList = ApplicationLinkGenerator.addFindAppsLink(linksList,
						apiUrl);
				linksList = ApplicationLinkGenerator.addUpdateAppLink(
						linksList, id, apiUrl);
				linksList = ApplicationLinkGenerator.addStartAppLink(linksList,
						id, apiUrl);
				linksList = ApplicationLinkGenerator.addStopAppLink(linksList,
						id, apiUrl);
				linksList = ApplicationLinkGenerator.addRestartAppLink(
						linksList, id, apiUrl);

				app.setLinksList(linksList);
				ApplicationPool2.INSTANCE2.add(app);
			}

		}
	}
	private synchronized Long getNextId() {
		return new Long(ApplicationPool2.INSTANCE2.getNextID());
	}
	
	public void run() {
		deployApplication(this.appwar, this.envwar, this.war);
	}
}
