package telecom.sudparis.eu.paas.core.server.xml.manifest;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.transform.stream.StreamSource;

public class Main {

	private static String manifestName = "";
	private static String manifestDesc = "";

	private static String appName = "";
	private static String appDesc = "";
	private static String appStartCommand = "";
	private static String appVersionName = "";
	private static String appVersionLabel = "";
	private static String appDeplName = "";
	private static String appDeplType = "";
	private static String appDeplLocation = "";
	private static String appDeplTenaLevel = "";
	private static String appComponentName = "";
	private static String appComponentDesc = "";
	private static String targetPass = "";
	private static String nameInstance = "";
	private static String nodeName = "";
	private static String envName = "";
	private static String envTemplateName = "";
	private static String envTemplateMemory = "";
	private static String envDesc = "";
	private static String envLinks = "";
	private static String envVariables = "";


	public static void main(String[] args) throws IOException {
		/*if(args.length !=1){
			System.err.println("Manifest file as argument");
		}*/
		String path="/home/mehdi/Bureau/COAPS/tmp/extension.xml";

		BufferedReader reader = new BufferedReader( new FileReader (path));
		String         line = null;
		StringBuilder  stringBuilder = new StringBuilder();
		String         ls = System.getProperty("line.separator");

		while( ( line = reader.readLine() ) != null ) {
			stringBuilder.append( line );
			stringBuilder.append( ls );
		}

		parseManifest(stringBuilder.toString());
	}

	public static void parseManifest(String manifestDescription) {
		try {
			if (manifestDescription != null) {
				InputStream is = new ByteArrayInputStream(
						manifestDescription.getBytes());

				JAXBContext jaxbContext;
				PaasApplicationManifest manifest = new PaasApplicationManifest();
				try {
					jaxbContext = JAXBContext
							.newInstance("telecom.sudparis.eu.paas.core.server.xml.manifest");
					Unmarshaller jaxbUnmarshaller = jaxbContext
							.createUnmarshaller();

					JAXBElement<PaasApplicationManifest> root = jaxbUnmarshaller
							.unmarshal(new StreamSource(is),
									PaasApplicationManifest.class);

					manifest = root.getValue();

				} catch (JAXBException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				manifestName = manifest.getName();
				System.out.println("manifestName: "+manifestName);
				manifestDesc = manifest.getDescription();
				System.out.println("manifestDesc: "+manifestDesc);
				List<PaasApplicationComponentType> lisComponent = manifest.getPaasApplication().getPaasApplicationComponent();

				if (lisComponent!= null) {
					for(PaasApplicationComponentType AppComponent: lisComponent){
						appComponentName = AppComponent.getName();
						System.out.println("appComponentName: "+appComponentName);
						appComponentDesc = AppComponent.getDescription();
						System.out.println("appComponentDesc: "+appComponentDesc);
						targetPass = AppComponent.getTargetPaas();
						System.out.println("targetPass: "+targetPass);

						List<PaasApplicationVersionType> lisVersion =
								AppComponent.getPaasApplicationVersion();

						if(lisVersion != null ){
							for(PaasApplicationVersionType AppVersion: lisVersion){
								appVersionName = AppVersion.getName();
								System.out.println("appVersionName: "+appVersionName);
								if (AppVersion.getLabel() != null){
									appVersionLabel = AppVersion.getLabel().toString();
									System.out.println("appVersionLabel: "+appVersionLabel);
								}
								if (AppVersion.getPaasApplicationDeployable() != null) {

									List<PaasApplicationDeployableType> lisDeployable =
											AppVersion.getPaasApplicationDeployable();
									if(lisDeployable != null){
										for(PaasApplicationDeployableType AppDeployable: lisDeployable){
											appDeplName = AppDeployable.getName();
											System.out.println("appDeplName: "+appDeplName);
											appDeplType = AppDeployable.getContentType();
											System.out.println("appDeplType: "+appDeplType);
											appDeplLocation = AppDeployable.getLocation();
											System.out.println("appDeplLocation: "+appDeplLocation);
											appDeplTenaLevel = AppDeployable.getMultitenancyLevel();
											System.out.println("appDeplTenaLevel: "+appDeplTenaLevel);
										}										
									}
									List<PaasApplicationVersionInstanceType> listInstances =
											AppVersion.getPaasApplicationVersionInstance();
									if(listInstances != null){
										for(PaasApplicationVersionInstanceType AppInstance: listInstances){
											nameInstance = AppInstance.getName();
										}
									}

								}
							}
						}
					}
				}

				/********************* Parse environnement ******************/
				List<PaasEnvironmentType> listEnvironnement  = manifest.getPaasApplication().getPaasEnvironment();
				if (listEnvironnement != null) {
					for(PaasEnvironmentType env: listEnvironnement){
						envName = env.getName();
						System.out.println("envName: "+envName);
						envTemplateName = env.getTemplate();
						System.out.println("envTemplateName: "+envTemplateName);

						if (env.getPaasEnvironmentTemplate() != null) {
							if (env.getPaasEnvironmentTemplate().getMemory() != null){
								envTemplateMemory = env.getPaasEnvironmentTemplate().getMemory()
										.toString();
								System.out.println("envTemplateMemory: "+envTemplateMemory);
							}
							envDesc = env.getPaasEnvironmentTemplate().getDescription();
							System.out.println("envDesc: "+envDesc);

							List<PaasEnvironmentNodeType> listEnvNodes = env.getPaasEnvironmentTemplate().getPaasEnvironmentNode();
							if(listEnvNodes!= null){
								for(PaasEnvironmentNodeType node:listEnvNodes){
									nodeName = node.getName();
									System.out.println("nodeName: "+nodeName);
								}

								List<PaasEnvironmentRelationType> listRelation = env.getPaasEnvironmentTemplate().getPaasEnvironmentRelation();
								if (listRelation != null){
									for(PaasEnvironmentRelationType relation : listRelation){
										List<PaasEnvironmentLinkType> listLink = relation.getPaasEnvironmentLink();
										if(listLink != null){
											for(PaasEnvironmentLinkType link : listLink){
												envLinks = link.getName();
												System.out.println("envLinks: "+envLinks);
											}										
										}
									}
								}
								if (env.getPaasEnvironmentTemplate().getPaasEnvironmentConfiguration() != null){
									List<PaasEnvironmentVariableType> listVariable = env.getPaasEnvironmentTemplate()
											.getPaasEnvironmentConfiguration().getPaasEnvironmentVariable();
									for(PaasEnvironmentVariableType variable:listVariable){
										envVariables = variable.getName();
										System.out.println("envVariables: "+envVariables);
									}
								}
							}

						}
					}
				}
			}
		} catch (Exception e) {
			System.out.println("Failed to create the environment: "
					+ e.getMessage());
			e.printStackTrace();
		}
	}
}
